
module DYAutomate
  class Command
    class Git <Command
      
      class TagAdd < Git

        # self.abstract_command = true
        self.command = 'tagAdd'
        self.summary = '添加新的tag'
        self.arguments = [
            CLAide::Argument.new('NAME',   true),
        ]

        # #要查询的lib名字
        # attr_accessor :name
        # #查询结果lib信息
        # attr_accessor :info

        def initialize(argv)
          # @name = argv.shift_argument
          super
        end

        def validate!
          super
          # unless @name
          #   help! 'need the lib `NAME`.'
          # end

          # unless existAtPools?
          #   help! "the podspec file is not exist at #{Dir.pwd}."
          # end
        end

        def run
          pp('tagAdd run ...',1)

        end

        def add_tag(newTag)

          @git_obj.tags.each{|x|
            if x.name.eql?(newTag)
              puts "Errror git --- #{newTag} has exist!"
            end
          }

          #git操作
            begin
              git.add(:all=>true)
              #提交更改
              git.commit("修改版本号 newTag")
              git.push
              
              #打tag
              git.add_tag(newTag, {:m => "tag更新"})
              #push tag
              git.push('origin','master',{:tags =>newTag})
            rescue
              git.reset_hard()
              puts "Errror git --- newTag"
            end
        end
      end

    end
  end
end