
module DYAutomate
  class Command
    class CodeGenerate < Command

      # require 'Command/pod/push.rb'
      # require 'Command/pod/version.rb'

      self.abstract_command = false
      self.command = 'code'
      self.summary = '按照模版，自动生成代码'
      # self.default_subcommand = 'list'
      self.arguments = [
          # CLAide::Argument.new('NAME',   true),
      ]

      #当前路径
      attr_accessor :path

      def initialize(argv)
        @path = Dir.pwd
        super
      end

      def validate!
        super
        unless @config.templates_git_url
            help! "
            error -- >!!! Not found <templates_git_url> in the #{DYAutomateConfig.configFilePath}"
        end
      end

      def run
          clone_templates
          exulateFile = File.join(@config.templates_cache_path,"ACMain.rb")
          if File.exist?(exulateFile)
            system("ruby #{exulateFile} #{Dir.pwd}")
          else
            UI.puts "cant find templates start file <ACMain.rb>."
          end
      end

      def clone_templates
        url = @config.templates_git_url
        path = @config.templates_cache_path
        system("rm -rf #{path}")
        unless Dir.exist?(path)
          Dir.mkdir(path,0777)
        end
        UI.puts("Cloning `#{url}` into `#{path}`.")
        system("git clone #{url} --depth 1 #{path}")

      end

      # def check_git_version
      #   versionFile = File.join(@config.templates_cache_path,"version")
      #   isSame = false
      #   if File.exist?(versionFile)
      #     versionContent = File.open(versionFile, 'r:utf-8', &:read)
      #     if versionContent
      #       isSame = versionContent.chomp.eql?(@git_tag.chomp)
      #     end
      #   end
      #   isSame
      # end

    end
  end
end
