require 'DYAutomate.rb'
require 'version'
require 'CustomConfig/DYAutomateConfig'
require 'Core/user_interface'

module DYAutomate
	require 'CLAide'
  include UI
	class Command < CLAide::Command
		require 'Command/pod.rb'
		require 'Command/workspace.rb'
		require 'Command/codeGenerate'
    require 'Command/codeSnippet'

    attr_accessor :config
		attr_accessor :env_str
		attr_accessor :repo_name

		self.abstract_command = true
	    self.command = 'dj'
	    self.version = VERSION
	    self.description = <<-Detail
	      iOS自动化工具集合
	    Detail
	    # self.plugin_prefixes = %w(claide DYAutomate)

	    def initialize(argv)
			super
			@config = DYAutomateConfig.loadConfig
			@env_str = @config.detailObj.env_str if @config
			@repoName = @config.detailObj.private_repo_name if @config
	    end

	    # def self.options
	    #   [
	    #     ['--silent', 'Show nothing'],
	    #   ].concat(super)
	    # end

	    def run
	      pp('automate works!!',1)
	    end

	    def pp(msg,level = 2)
	    	unless msg
	    		return
	    	end

	    	if level == 1
					puts msg.white if msg
				elsif level == 2
					puts msg.red if msg
	    	end
			end
      #
			# def repoName
			# 	@repoName = @config.detailObj.private_repo_name if @config
			# 	@repoName
			# end
      #
			# def env_str
			# 	@env_str = @config.detailObj.env_str if @config
			# 	@env_str
			# end

	end
end
