
module DYAutomate
  class Command
    class Pod <Command
      class Version < Pod

        # self.abstract_command = true
        self.command = 'ver'
        self.summary = "
        修改podspec文件版本号 `dj pod ver 1` 0.1.0 --> 0.1.1
          `dj pod ver 1 1`  0.1.0 --> 0.2.1
          `dj pod ver 0 1` 0.1.0 --> 0.2.0
        "
        self.arguments = [
            CLAide::Argument.new('addVersion', false,'升级一个小版本'),
            CLAide::Argument.new('addBigVersion', false)
        ]

        # def self.options
        #   [
        #     ['--add', '增加一个小版本'],
        #     # ['-minus', ' 减少一个小版本'],
        #     ['--addBig', '增加一个大版本'],
        #     # ['-minusBig', ' 减少一个大版本'],
        #   ].concat(super)
        # end

        def initialize(argv)
          @add = argv.shift_argument
          @addBig = argv.shift_argument
          super
        end

        def run
          if @add.to_i > 0
            pp('增加一个小版本',1)
            new_v = get_version_new
            fix_pod_version(new_v)
          end
          if @addBig.to_i > 0
            pp('增加一个大版本',1)
            new_v = get_version_big_new

            fix_pod_version(new_v)
          end
        end

        def fix_pod_version(new_version)
          if new_version
            #查找内容
            targetLine = file_line_match(@spec_path,/s.version *=/)
            newLine = "  s.version          = '#{new_version}' \n"
            file_line_match_replace(@spec_path,/s.version *=/,newLine)
            pp(get_spec_version,1)
          else
            pp('fix_pod_version error,new_version is nil',1)
          end
        end

      end
    end
  end
end
